# Learning Robot Trajectories subject to Kinematic Joint Constraints

The aim of this package is to enable learning of robot trajectories without without exceeding limits on the position, velocity, acceleration and jerk of each robot joint.
Movements are generated by mapping the predictions of a neural network to safely executable joint accelerations. \
This package provides the code to compute the range of safely executable joint accelerations.

## Installation

The package can be installed by running

    pip install klimits

## Trajectory generation

To generate a random trajectory with limited jerk, acceleration, velocity and position run

    python -m klimits.test_trajectory_generation

Several parameters can be adjusted to modify the generated trajectory.
Run

    python -m klimits.test_trajectory_generation --help

for further details.



## Further reading

A preprint of the corresponding publication is available at [arXiv.org](https://arxiv.org/abs/2011.00563). \
Further information on the implementation can be found [here](https://www.researchgate.net/publication/350451653_Background_Knowledge_for_Learning_Robot_Trajectories_subject_to_Kinematic_Joint_Constraints). \
This library is used by [safeMotions](https://github.com/translearn/safemotions) to learn collision-free reaching tasks via reinforcement learning.

## Video

[![Video](https://img.youtube.com/vi/JpkKCd9jyss/0.jpg)](https://www.youtube.com/watch?v=JpkKCd9jyss)

## Disclaimer

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
