#include "_klimits_code.h"
#include <math.h>

double pos_all_a1_max(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_n_a_min) {

   double result;
   result = (1.0/6.0)*sqrt(3)*sqrt(a_min*(2*a_0*pow(t_s, 2) + 6*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*pow(t_n_a_min, 2) + 2*j_min*pow(t_s, 2)*t_n_a_min - 2*j_min*pow(t_n_a_min, 3) + 24*p_0 - 24*p_max + 12*t_s*v_0 + 12*t_n_a_min*v_0))/t_n_a_min - 1.0/2.0*(a_0*t_s - a_min*t_n_a_min - j_min*t_s*t_n_a_min + j_min*pow(t_n_a_min, 2) + 2*v_0)/t_n_a_min;
   return result;

}

double pos_all_a1_min(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_n_a_min) {

   double result;
   result = -1.0/6.0*sqrt(3)*sqrt(a_min*(2*a_0*pow(t_s, 2) + 6*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*pow(t_n_a_min, 2) + 2*j_min*pow(t_s, 2)*t_n_a_min - 2*j_min*pow(t_n_a_min, 3) + 24*p_0 - 24*p_max + 12*t_s*v_0 + 12*t_n_a_min*v_0))/t_n_a_min - 1.0/2.0*(a_0*t_s - a_min*t_n_a_min - j_min*t_s*t_n_a_min + j_min*pow(t_n_a_min, 2) + 2*v_0)/t_n_a_min;
   return result;

}

double pos_all_bounded_vel_continuous_a1(double j_min, double j_max, double a_0, double a_min, double v_0, double t_s, double t_star, double t_n_a_min, double t_u) {

   double result;
   result = (1.0/2.0)*(-a_0*t_s + a_min*t_s + 2*a_min*t_n_a_min - 2*a_min*t_star - j_max*pow(t_star, 2) + 2*j_max*t_star*t_u - j_max*pow(t_u, 2) + j_min*t_s*t_n_a_min - j_min*pow(t_n_a_min, 2) - 2*v_0)/t_n_a_min;
   return result;

}

double complex pos_all_bounded_vel_continuous_tu(double j_min, double j_max, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_star, double t_n_a_min) {

   double complex result;
   result = (1.0/2.0)*t_s + (1.0/2.0)*t_n_a_min - (-9*t_s*t_star - 9*t_n_a_min*t_star + 9*cpow(t_star, 2) + cpow(-3.0/2.0*t_s - 3.0/2.0*t_n_a_min, 2))*cpow(cpow(-3.0/2.0*t_s - 3.0/2.0*t_n_a_min, 3) + (1.0/2.0)*((27.0/2.0)*t_s + (27.0/2.0)*t_n_a_min)*(3*t_s*t_star + 3*t_n_a_min*t_star - 3*cpow(t_star, 2)) + (1.0/2.0)*csqrt(cpow(2*cpow(-3.0/2.0*t_s - 3.0/2.0*t_n_a_min, 3) + ((27.0/2.0)*t_s + (27.0/2.0)*t_n_a_min)*(3*t_s*t_star + 3*t_n_a_min*t_star - 3*cpow(t_star, 2)) + (1.0/2.0)*(-27*a_0*cpow(t_s, 2) - 81*a_0*t_s*t_n_a_min + 27*a_min*cpow(t_s, 2) + 81*a_min*t_s*t_n_a_min - 162*a_min*t_s*t_star - 162*a_min*t_n_a_min*t_star + 162*a_min*cpow(t_star, 2) - 81*j_max*t_s*cpow(t_star, 2) - 81*j_max*t_n_a_min*cpow(t_star, 2) + 108*j_max*cpow(t_star, 3) - 27*j_min*cpow(t_s, 2)*t_n_a_min + 27*j_min*cpow(t_n_a_min, 3) - 324*p_0 + 324*p_max - 162*t_s*v_0 - 162*t_n_a_min*v_0)/j_max, 2) - 4*cpow(-9*t_s*t_star - 9*t_n_a_min*t_star + 9*cpow(t_star, 2) + cpow(-3.0/2.0*t_s - 3.0/2.0*t_n_a_min, 2), 3)) + (1.0/4.0)*(-27*a_0*cpow(t_s, 2) - 81*a_0*t_s*t_n_a_min + 27*a_min*cpow(t_s, 2) + 81*a_min*t_s*t_n_a_min - 162*a_min*t_s*t_star - 162*a_min*t_n_a_min*t_star + 162*a_min*cpow(t_star, 2) - 81*j_max*t_s*cpow(t_star, 2) - 81*j_max*t_n_a_min*cpow(t_star, 2) + 108*j_max*cpow(t_star, 3) - 27*j_min*cpow(t_s, 2)*t_n_a_min + 27*j_min*cpow(t_n_a_min, 3) - 324*p_0 + 324*p_max - 162*t_s*v_0 - 162*t_n_a_min*v_0)/j_max, -0.33333333333333331)/(-1.5 - 3.0/2.0*csqrt(3)*I) - 1.0/3.0*(-0.5 - 1.0/2.0*csqrt(3)*I)*cpow(cpow(-3.0/2.0*t_s - 3.0/2.0*t_n_a_min, 3) + (1.0/2.0)*((27.0/2.0)*t_s + (27.0/2.0)*t_n_a_min)*(3*t_s*t_star + 3*t_n_a_min*t_star - 3*cpow(t_star, 2)) + (1.0/2.0)*csqrt(cpow(2*cpow(-3.0/2.0*t_s - 3.0/2.0*t_n_a_min, 3) + ((27.0/2.0)*t_s + (27.0/2.0)*t_n_a_min)*(3*t_s*t_star + 3*t_n_a_min*t_star - 3*cpow(t_star, 2)) + (1.0/2.0)*(-27*a_0*cpow(t_s, 2) - 81*a_0*t_s*t_n_a_min + 27*a_min*cpow(t_s, 2) + 81*a_min*t_s*t_n_a_min - 162*a_min*t_s*t_star - 162*a_min*t_n_a_min*t_star + 162*a_min*cpow(t_star, 2) - 81*j_max*t_s*cpow(t_star, 2) - 81*j_max*t_n_a_min*cpow(t_star, 2) + 108*j_max*cpow(t_star, 3) - 27*j_min*cpow(t_s, 2)*t_n_a_min + 27*j_min*cpow(t_n_a_min, 3) - 324*p_0 + 324*p_max - 162*t_s*v_0 - 162*t_n_a_min*v_0)/j_max, 2) - 4*cpow(-9*t_s*t_star - 9*t_n_a_min*t_star + 9*cpow(t_star, 2) + cpow(-3.0/2.0*t_s - 3.0/2.0*t_n_a_min, 2), 3)) + (1.0/4.0)*(-27*a_0*cpow(t_s, 2) - 81*a_0*t_s*t_n_a_min + 27*a_min*cpow(t_s, 2) + 81*a_min*t_s*t_n_a_min - 162*a_min*t_s*t_star - 162*a_min*t_n_a_min*t_star + 162*a_min*cpow(t_star, 2) - 81*j_max*t_s*cpow(t_star, 2) - 81*j_max*t_n_a_min*cpow(t_star, 2) + 108*j_max*cpow(t_star, 3) - 27*j_min*cpow(t_s, 2)*t_n_a_min + 27*j_min*cpow(t_n_a_min, 3) - 324*p_0 + 324*p_max - 162*t_s*v_0 - 162*t_n_a_min*v_0)/j_max, 0.33333333333333331);
   return result;

}

double pos_all_bounded_vel_discrete_a1(double j_min, double j_max, double j_n_u_plus_1, double a_0, double a_min, double v_0, double t_s, double t_star, double t_n_a_min, double t_n_u) {

   double result;
   result = (1.0/2.0)*(-a_0*t_s + a_min*t_s + 2*a_min*t_n_a_min - 2*a_min*t_star - j_max*pow(t_s, 2) - 2*j_max*t_s*t_n_u + 2*j_max*t_s*t_star - j_max*pow(t_n_u, 2) + 2*j_max*t_n_u*t_star - j_max*pow(t_star, 2) + j_min*t_s*t_n_a_min - j_min*pow(t_n_a_min, 2) + j_n_u_plus_1*pow(t_s, 2) + 2*j_n_u_plus_1*t_s*t_n_u - 2*j_n_u_plus_1*t_s*t_star - 2*v_0)/t_n_a_min;
   return result;

}

double pos_all_bounded_vel_discrete_j_n_u_plus_1(double j_min, double j_max, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_star, double t_n_a_min, double t_n_u) {

   double result;
   result = (a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 6*a_min*t_s*t_star + 6*a_min*t_n_a_min*t_star - 6*a_min*pow(t_star, 2) + j_max*pow(t_s, 3) + 3*j_max*pow(t_s, 2)*t_n_a_min - 6*j_max*pow(t_s, 2)*t_star + 6*j_max*t_s*t_n_a_min*t_n_u - 6*j_max*t_s*t_n_a_min*t_star - 3*j_max*t_s*pow(t_n_u, 2) - 6*j_max*t_s*t_n_u*t_star + 9*j_max*t_s*pow(t_star, 2) + 3*j_max*t_n_a_min*pow(t_n_u, 2) - 6*j_max*t_n_a_min*t_n_u*t_star + 3*j_max*t_n_a_min*pow(t_star, 2) - 2*j_max*pow(t_n_u, 3) + 6*j_max*t_n_u*pow(t_star, 2) - 4*j_max*pow(t_star, 3) + j_min*pow(t_s, 2)*t_n_a_min - j_min*pow(t_n_a_min, 3) + 12*p_0 - 12*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/(t_s*(pow(t_s, 2) + 3*t_s*t_n_a_min - 6*t_s*t_star + 6*t_n_a_min*t_n_u - 6*t_n_a_min*t_star - 6*pow(t_n_u, 2) + 6*pow(t_star, 2)));
   return result;

}

double pos_all_tv0(double j_min, double a_0, double a_1, double a_min, double v_0, double t_s, double t_n_a_min) {

   double result;
   result = (1.0/2.0)*(-2*a_0*t_s + 2*a_min*(t_s + t_n_a_min) + j_min*pow(t_s, 2) - j_min*pow(t_n_a_min, 2) + t_s*(a_0 - a_1) + 2*t_s*(a_1 - j_min*t_s) - 2*t_n_a_min*(a_1 - j_min*t_s) - 2*v_0 - pow(t_n_a_min, 2)*(a_1 - a_min - j_min*t_s + j_min*t_n_a_min)/t_s + 2*t_n_a_min*(a_1*t_s + a_1*t_n_a_min - a_min*t_n_a_min - j_min*pow(t_s, 2) + j_min*pow(t_n_a_min, 2))/t_s + pow(t_s + t_n_a_min, 2)*(a_1 - a_min - j_min*t_s + j_min*t_n_a_min)/t_s - (2*t_s + 2*t_n_a_min)*(a_1*t_s + a_1*t_n_a_min - a_min*t_n_a_min - j_min*pow(t_s, 2) + j_min*pow(t_n_a_min, 2))/t_s)/a_min;
   return result;

}

double pos_first_a1(double a_0, double v_0, double t_s, double t_v0) {

   double result;
   result = a_0 - 2*t_s*(a_0*t_v0 + v_0)/pow(t_v0, 2);
   return result;

}

double pos_first_tv0_max(double a_0, double v_0, double p_0, double p_max) {

   double result;
   result = -2*v_0/a_0 + 1.4142135623730951*sqrt(-3*a_0*p_0 + 3*a_0*p_max + 2*pow(v_0, 2))/a_0;
   return result;

}

double pos_first_tv0_min(double a_0, double v_0, double p_0, double p_max) {

   double result;
   result = -2*v_0/a_0 - 1.4142135623730951*sqrt(-3*a_0*p_0 + 3*a_0*p_max + 2*pow(v_0, 2))/a_0;
   return result;

}

double pos_min_jerk_a1(double j_min, double a_0, double v_0, double t_s, double t_v0) {

   double result;
   result = (a_0*t_s + j_min*pow(t_s, 2) - 2*j_min*t_s*t_v0 + j_min*pow(t_v0, 2) + 2*v_0)/(t_s - 2*t_v0);
   return result;

}

double pos_min_jerk_bounded_vel_continuous_a1(double j_min, double j_max, double a_0, double v_0, double t_s, double t_star, double t_u) {

   double result;
   result = (a_0*t_s + j_max*pow(t_star, 2) - 2*j_max*t_star*t_u + j_max*pow(t_u, 2) + j_min*pow(t_s, 2) - 2*j_min*t_s*t_star + 2*j_min*t_star*t_u - j_min*pow(t_u, 2) + 2*v_0)/(t_s - 2*t_star);
   return result;

}

double complex pos_min_jerk_bounded_vel_continuous_tu(double j_min, double j_max, double a_0, double v_0, double p_0, double p_max, double t_s, double t_star) {

   double complex result;
   result = (-(-6*cpow(t_s, 2)*t_star + 9*t_s*cpow(t_star, 2))/(t_s - 2*t_star) - cpow(-cpow(t_s, 2) + 3*cpow(t_star, 2), 2)/cpow(t_s - 2*t_star, 2))*cpow((1.0/2.0)*csqrt(-4*cpow((-6*cpow(t_s, 2)*t_star + 9*t_s*cpow(t_star, 2))/(t_s - 2*t_star) + cpow(-cpow(t_s, 2) + 3*cpow(t_star, 2), 2)/cpow(t_s - 2*t_star, 2), 3) + cpow((-54*a_0*cpow(t_s, 2)*t_star + 81*a_0*t_s*cpow(t_star, 2) - 27*j_max*cpow(t_s, 2)*cpow(t_star, 2) + 54*j_max*t_s*cpow(t_star, 3) - 27*j_max*cpow(t_star, 4) - 162*p_0*t_s + 324*p_0*t_star + 162*p_max*t_s - 324*p_max*t_star - 54*cpow(t_s, 2)*v_0 + 162*cpow(t_star, 2)*v_0)/(j_max*t_s - 2*j_max*t_star - j_min*t_s + 2*j_min*t_star) - (-9*cpow(t_s, 2) + 27*cpow(t_star, 2))*(2*cpow(t_s, 2)*t_star - 3*t_s*cpow(t_star, 2))/cpow(t_s - 2*t_star, 2) + 2*cpow(-cpow(t_s, 2) + 3*cpow(t_star, 2), 3)/cpow(t_s - 2*t_star, 3), 2)) + (-54*a_0*cpow(t_s, 2)*t_star + 81*a_0*t_s*cpow(t_star, 2) - 27*j_max*cpow(t_s, 2)*cpow(t_star, 2) + 54*j_max*t_s*cpow(t_star, 3) - 27*j_max*cpow(t_star, 4) - 162*p_0*t_s + 324*p_0*t_star + 162*p_max*t_s - 324*p_max*t_star - 54*cpow(t_s, 2)*v_0 + 162*cpow(t_star, 2)*v_0)/(2*j_max*t_s - 4*j_max*t_star - 2*j_min*t_s + 4*j_min*t_star) - 1.0/2.0*(-9*cpow(t_s, 2) + 27*cpow(t_star, 2))*(2*cpow(t_s, 2)*t_star - 3*t_s*cpow(t_star, 2))/cpow(t_s - 2*t_star, 2) + cpow(-cpow(t_s, 2) + 3*cpow(t_star, 2), 3)/cpow(t_s - 2*t_star, 3), -0.33333333333333331)/(-1.5 + (3.0/2.0)*csqrt(3)*I) - 1.0/3.0*(-0.5 + (1.0/2.0)*csqrt(3)*I)*cpow((1.0/2.0)*csqrt(-4*cpow((-6*cpow(t_s, 2)*t_star + 9*t_s*cpow(t_star, 2))/(t_s - 2*t_star) + cpow(-cpow(t_s, 2) + 3*cpow(t_star, 2), 2)/cpow(t_s - 2*t_star, 2), 3) + cpow((-54*a_0*cpow(t_s, 2)*t_star + 81*a_0*t_s*cpow(t_star, 2) - 27*j_max*cpow(t_s, 2)*cpow(t_star, 2) + 54*j_max*t_s*cpow(t_star, 3) - 27*j_max*cpow(t_star, 4) - 162*p_0*t_s + 324*p_0*t_star + 162*p_max*t_s - 324*p_max*t_star - 54*cpow(t_s, 2)*v_0 + 162*cpow(t_star, 2)*v_0)/(j_max*t_s - 2*j_max*t_star - j_min*t_s + 2*j_min*t_star) - (-9*cpow(t_s, 2) + 27*cpow(t_star, 2))*(2*cpow(t_s, 2)*t_star - 3*t_s*cpow(t_star, 2))/cpow(t_s - 2*t_star, 2) + 2*cpow(-cpow(t_s, 2) + 3*cpow(t_star, 2), 3)/cpow(t_s - 2*t_star, 3), 2)) + (-54*a_0*cpow(t_s, 2)*t_star + 81*a_0*t_s*cpow(t_star, 2) - 27*j_max*cpow(t_s, 2)*cpow(t_star, 2) + 54*j_max*t_s*cpow(t_star, 3) - 27*j_max*cpow(t_star, 4) - 162*p_0*t_s + 324*p_0*t_star + 162*p_max*t_s - 324*p_max*t_star - 54*cpow(t_s, 2)*v_0 + 162*cpow(t_star, 2)*v_0)/(2*j_max*t_s - 4*j_max*t_star - 2*j_min*t_s + 4*j_min*t_star) - 1.0/2.0*(-9*cpow(t_s, 2) + 27*cpow(t_star, 2))*(2*cpow(t_s, 2)*t_star - 3*t_s*cpow(t_star, 2))/cpow(t_s - 2*t_star, 2) + cpow(-cpow(t_s, 2) + 3*cpow(t_star, 2), 3)/cpow(t_s - 2*t_star, 3), 0.33333333333333331) - (-cpow(t_s, 2) + 3*cpow(t_star, 2))/(3*t_s - 6*t_star);
   return result;

}

double pos_min_jerk_bounded_vel_discrete_a1(double j_min, double j_max, double j_n_u_plus_1, double a_0, double v_0, double t_s, double t_star, double t_n_u) {

   double result;
   result = (a_0*t_s + j_max*pow(t_s, 2) + 2*j_max*t_s*t_n_u - 2*j_max*t_s*t_star + j_max*pow(t_n_u, 2) - 2*j_max*t_n_u*t_star + j_max*pow(t_star, 2) + j_min*pow(t_s, 2) - 2*j_min*t_s*t_star - j_min*pow(t_n_u, 2) + 2*j_min*t_n_u*t_star - j_n_u_plus_1*pow(t_s, 2) - 2*j_n_u_plus_1*t_s*t_n_u + 2*j_n_u_plus_1*t_s*t_star + 2*v_0)/(t_s - 2*t_star);
   return result;

}

double pos_min_jerk_bounded_vel_discrete_j_n_u_plus_1(double j_min, double j_max, double a_0, double v_0, double p_0, double p_max, double t_s, double t_star, double t_n_u) {

   double result;
   result = (-2*a_0*pow(t_s, 2)*t_star + 3*a_0*t_s*pow(t_star, 2) + j_max*pow(t_s, 3)*t_n_u + 2*j_max*pow(t_s, 2)*pow(t_n_u, 2) - 4*j_max*pow(t_s, 2)*t_n_u*t_star - j_max*pow(t_s, 2)*pow(t_star, 2) + j_max*t_s*pow(t_n_u, 3) - 6*j_max*t_s*pow(t_n_u, 2)*t_star + 3*j_max*t_s*t_n_u*pow(t_star, 2) + 2*j_max*t_s*pow(t_star, 3) - 2*j_max*pow(t_n_u, 3)*t_star + 3*j_max*pow(t_n_u, 2)*pow(t_star, 2) - j_max*pow(t_star, 4) + j_min*pow(t_s, 2)*pow(t_n_u, 2) - 2*j_min*pow(t_s, 2)*t_n_u*t_star - j_min*t_s*pow(t_n_u, 3) + 3*j_min*t_s*t_n_u*pow(t_star, 2) + 2*j_min*pow(t_n_u, 3)*t_star - 3*j_min*pow(t_n_u, 2)*pow(t_star, 2) - 6*p_0*t_s + 12*p_0*t_star + 6*p_max*t_s - 12*p_max*t_star - 2*pow(t_s, 2)*v_0 + 6*pow(t_star, 2)*v_0)/(t_s*t_n_u*(pow(t_s, 2) + 3*t_s*t_n_u - 6*t_s*t_star - 6*t_n_u*t_star + 6*pow(t_star, 2)));
   return result;

}

double pos_min_jerk_tv0_0(double j_min, double a_0, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = 2*t_s*(-2*t_s*((3.0/64.0)*pow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*pow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (1.0/12.0)*pow(-3.0/2.0*pow(t_s, 2) + (-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min, 2) + (6*p_0*t_s - 6*p_max*t_s + 2*pow(t_s, 2)*v_0)/j_min;
   return result;

}

double pos_min_jerk_tv0_1(double j_min, double a_0, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = (1.0/2.0)*t_s + (1.0/2.0)*sqrt(pow(t_s, 2) - 2*pow(-1.0/108.0*pow(-3.0/2.0*pow(t_s, 2) + (-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*pow(t_s, 2) + (-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*pow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*pow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*pow(t_s, 2)*v_0)/j_min) - 1.0/8.0*pow(-2*t_s*((1.0/2.0)*pow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*pow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 0.33333333333333331) - 1.0/3.0*(-6*a_0*t_s + 2*j_min*pow(t_s, 2) - 12*v_0)/j_min) + (1.0/2.0)*sqrt(2*pow(t_s, 2) - (-4*t_s*((1.0/2.0)*pow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min) + (4*a_0*pow(t_s, 2) - 24*p_0 + 24*p_max)/j_min)/sqrt(pow(t_s, 2) - 2*pow(-1.0/108.0*pow(-3.0/2.0*pow(t_s, 2) + (-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*pow(t_s, 2) + (-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*pow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*pow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*pow(t_s, 2)*v_0)/j_min) - 1.0/8.0*pow(-2*t_s*((1.0/2.0)*pow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*pow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 0.33333333333333331) - 1.0/3.0*(-6*a_0*t_s + 2*j_min*pow(t_s, 2) - 12*v_0)/j_min) + 2*pow(-1.0/108.0*pow(-3.0/2.0*pow(t_s, 2) + (-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*pow(t_s, 2) + (-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*pow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*pow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*pow(t_s, 2)*v_0)/j_min) - 1.0/8.0*pow(-2*t_s*((1.0/2.0)*pow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*pow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*pow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 0.33333333333333331) - 1.0/3.0*(-12*a_0*t_s + 4*j_min*pow(t_s, 2) - 24*v_0)/j_min);
   return result;

}

double complex pos_min_jerk_tv0_2(double j_min, double a_0, double v_0, double p_0, double p_max, double t_s) {

   double complex result;
   result = (1.0/2.0)*t_s + (1.0/2.0)*csqrt(cpow(t_s, 2) - 1.0/3.0*(-4*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/6.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - 2*(6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min)*cpow((1.0/216.0)*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) - 1.0/6.0*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) + (1.0/16.0)*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2) + csqrt((1.0/27.0)*cpow(-2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/12.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) - 1.0/8.0*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 2)), -0.33333333333333331) + 2*cpow((1.0/216.0)*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) - 1.0/6.0*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) + (1.0/16.0)*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2) + csqrt((1.0/27.0)*cpow(-2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/12.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) - 1.0/8.0*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-6*a_0*t_s + 2*j_min*cpow(t_s, 2) - 12*v_0)/j_min) + (1.0/2.0)*csqrt(2*cpow(t_s, 2) - (-4*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (4*a_0*cpow(t_s, 2) - 24*p_0 + 24*p_max)/j_min)/csqrt(cpow(t_s, 2) - 1.0/3.0*(-4*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/6.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - 2*(6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min)*cpow((1.0/216.0)*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) - 1.0/6.0*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) + (1.0/16.0)*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2) + csqrt((1.0/27.0)*cpow(-2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/12.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) - 1.0/8.0*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 2)), -0.33333333333333331) + 2*cpow((1.0/216.0)*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) - 1.0/6.0*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) + (1.0/16.0)*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2) + csqrt((1.0/27.0)*cpow(-2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/12.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) - 1.0/8.0*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-6*a_0*t_s + 2*j_min*cpow(t_s, 2) - 12*v_0)/j_min) + (1.0/3.0)*(-4*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/6.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - 2*(6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min)*cpow((1.0/216.0)*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) - 1.0/6.0*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) + (1.0/16.0)*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2) + csqrt((1.0/27.0)*cpow(-2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/12.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) - 1.0/8.0*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 2)), -0.33333333333333331) - 2*cpow((1.0/216.0)*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) - 1.0/6.0*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) + (1.0/16.0)*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2) + csqrt((1.0/27.0)*cpow(-2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) - 1.0/12.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 2) - (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min, 3) + (1.0/3.0)*(-3.0/2.0*cpow(t_s, 2) + (-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min)*(2*t_s*(-2*t_s*((3.0/64.0)*cpow(t_s, 2) - 1.0/16.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (1.0/4.0)*(2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min) + (6*p_0*t_s - 6*p_max*t_s + 2*cpow(t_s, 2)*v_0)/j_min) - 1.0/8.0*cpow(-2*t_s*((1.0/2.0)*cpow(t_s, 2) - 1.0/2.0*(-3*a_0*t_s + j_min*cpow(t_s, 2) - 6*v_0)/j_min) + (2*a_0*cpow(t_s, 2) - 12*p_0 + 12*p_max)/j_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-12*a_0*t_s + 4*j_min*cpow(t_s, 2) - 24*v_0)/j_min);
   return result;

}

double pos_reduced_jerk_a1(double j_min, double a_0, double a_min, double v_0, double t_s, double t_v0, double t_n_a_min) {

   double result;
   result = (a_0*pow(t_s, 2) + a_min*pow(t_n_a_min, 2) - 2*a_min*t_n_a_min*t_v0 + a_min*pow(t_v0, 2) + j_min*pow(t_s, 3) - 2*j_min*pow(t_s, 2)*t_v0 + j_min*t_s*pow(t_v0, 2) - j_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_n_a_min, 2)*t_v0 - j_min*t_n_a_min*pow(t_v0, 2) + 2*t_s*v_0)/(pow(t_s, 2) - 2*t_s*t_v0 + pow(t_n_a_min, 2) - 2*t_n_a_min*t_v0 + pow(t_v0, 2));
   return result;

}

double pos_reduced_jerk_tv0_0(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_n_a_min) {

   double result;
   result = (1.0/12.0)*pow((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2), 2) - (((1.0/16.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*pow(t_s, 2)*pow(t_n_a_min, 2) + a_0*t_s*pow(t_n_a_min, 3) + a_min*pow(t_s, 2)*pow(t_n_a_min, 2) - a_min*t_s*pow(t_n_a_min, 3) - j_min*pow(t_s, 3)*pow(t_n_a_min, 2) + j_min*t_s*pow(t_n_a_min, 4) + 6*p_0*pow(t_s, 2) + 6*p_0*pow(t_n_a_min, 2) - 6*p_max*pow(t_s, 2) - 6*p_max*pow(t_n_a_min, 2) + 2*pow(t_s, 3)*v_0 + 2*pow(t_n_a_min, 3)*v_0)/a_min;
   return result;

}

double pos_reduced_jerk_tv0_1(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_n_a_min) {

   double result;
   result = -1.0/2.0*sqrt(-2*pow(-1.0/108.0*pow((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*((-((1.0/16.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*pow(t_s, 2)*pow(t_n_a_min, 2) + a_0*t_s*pow(t_n_a_min, 3) + a_min*pow(t_s, 2)*pow(t_n_a_min, 2) - a_min*t_s*pow(t_n_a_min, 3) - j_min*pow(t_s, 3)*pow(t_n_a_min, 2) + j_min*t_s*pow(t_n_a_min, 4) + 6*p_0*pow(t_s, 2) + 6*p_0*pow(t_n_a_min, 2) - 6*p_max*pow(t_s, 2) - 6*p_max*pow(t_n_a_min, 2) + 2*pow(t_s, 3)*v_0 + 2*pow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*pow(((1.0/2.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 0.33333333333333331) - 1.0/3.0*(-8*a_0*pow(t_s, 2) - 6*a_0*t_s*t_n_a_min + 2*a_min*pow(t_s, 2) + 6*a_min*t_s*t_n_a_min - 6*a_min*pow(t_n_a_min, 2) - 8*j_min*pow(t_s, 2)*t_n_a_min + 8*j_min*pow(t_n_a_min, 3) + 12*p_0 - 12*p_max - 12*t_s*v_0 - 12*t_n_a_min*v_0)/a_min + (1.0/4.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2)) + (1.0/2.0)*sqrt((((4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/4.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (4*a_0*pow(t_s, 3) + 4*a_0*pow(t_s, 2)*t_n_a_min - 4*a_min*pow(t_s, 2)*t_n_a_min + 4*a_min*pow(t_n_a_min, 3) + 4*j_min*pow(t_s, 3)*t_n_a_min + 4*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 4*j_min*t_s*pow(t_n_a_min, 3) - 4*j_min*pow(t_n_a_min, 4) - 24*p_0*t_s - 24*p_0*t_n_a_min + 24*p_max*t_s + 24*p_max*t_n_a_min)/a_min)/sqrt(-2*pow(-1.0/108.0*pow((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*((-((1.0/16.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*pow(t_s, 2)*pow(t_n_a_min, 2) + a_0*t_s*pow(t_n_a_min, 3) + a_min*pow(t_s, 2)*pow(t_n_a_min, 2) - a_min*t_s*pow(t_n_a_min, 3) - j_min*pow(t_s, 3)*pow(t_n_a_min, 2) + j_min*t_s*pow(t_n_a_min, 4) + 6*p_0*pow(t_s, 2) + 6*p_0*pow(t_n_a_min, 2) - 6*p_max*pow(t_s, 2) - 6*p_max*pow(t_n_a_min, 2) + 2*pow(t_s, 3)*v_0 + 2*pow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*pow(((1.0/2.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 0.33333333333333331) - 1.0/3.0*(-8*a_0*pow(t_s, 2) - 6*a_0*t_s*t_n_a_min + 2*a_min*pow(t_s, 2) + 6*a_min*t_s*t_n_a_min - 6*a_min*pow(t_n_a_min, 2) - 8*j_min*pow(t_s, 2)*t_n_a_min + 8*j_min*pow(t_n_a_min, 3) + 12*p_0 - 12*p_max - 12*t_s*v_0 - 12*t_n_a_min*v_0)/a_min + (1.0/4.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2)) + 2*pow(-1.0/108.0*pow((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*((-((1.0/16.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*pow(t_s, 2)*pow(t_n_a_min, 2) + a_0*t_s*pow(t_n_a_min, 3) + a_min*pow(t_s, 2)*pow(t_n_a_min, 2) - a_min*t_s*pow(t_n_a_min, 3) - j_min*pow(t_s, 3)*pow(t_n_a_min, 2) + j_min*t_s*pow(t_n_a_min, 4) + 6*p_0*pow(t_s, 2) + 6*p_0*pow(t_n_a_min, 2) - 6*p_max*pow(t_s, 2) - 6*p_max*pow(t_n_a_min, 2) + 2*pow(t_s, 3)*v_0 + 2*pow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*pow(((1.0/2.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 0.33333333333333331) - 1.0/3.0*(-16*a_0*pow(t_s, 2) - 12*a_0*t_s*t_n_a_min + 4*a_min*pow(t_s, 2) + 12*a_min*t_s*t_n_a_min - 12*a_min*pow(t_n_a_min, 2) - 16*j_min*pow(t_s, 2)*t_n_a_min + 16*j_min*pow(t_n_a_min, 3) + 24*p_0 - 24*p_max - 24*t_s*v_0 - 24*t_n_a_min*v_0)/a_min + (1.0/2.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2)) - 1.0/4.0*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min;
   return result;

}

double complex pos_reduced_jerk_tv0_2(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_n_a_min) {

   double complex result;
   result = -1.0/2.0*csqrt((1.0/3.0)*((1.0/6.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) - 2*(((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + 2*(-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min)*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), -0.33333333333333331) + 2*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-8*a_0*cpow(t_s, 2) - 6*a_0*t_s*t_n_a_min + 2*a_min*cpow(t_s, 2) + 6*a_min*t_s*t_n_a_min - 6*a_min*cpow(t_n_a_min, 2) - 8*j_min*cpow(t_s, 2)*t_n_a_min + 8*j_min*cpow(t_n_a_min, 3) + 12*p_0 - 12*p_max - 12*t_s*v_0 - 12*t_n_a_min*v_0)/a_min + (1.0/4.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2)) + (1.0/2.0)*csqrt((((4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/4.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (4*a_0*cpow(t_s, 3) + 4*a_0*cpow(t_s, 2)*t_n_a_min - 4*a_min*cpow(t_s, 2)*t_n_a_min + 4*a_min*cpow(t_n_a_min, 3) + 4*j_min*cpow(t_s, 3)*t_n_a_min + 4*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 4*j_min*t_s*cpow(t_n_a_min, 3) - 4*j_min*cpow(t_n_a_min, 4) - 24*p_0*t_s - 24*p_0*t_n_a_min + 24*p_max*t_s + 24*p_max*t_n_a_min)/a_min)/csqrt((1.0/3.0)*((1.0/6.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) - 2*(((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + 2*(-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min)*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), -0.33333333333333331) + 2*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-8*a_0*cpow(t_s, 2) - 6*a_0*t_s*t_n_a_min + 2*a_min*cpow(t_s, 2) + 6*a_min*t_s*t_n_a_min - 6*a_min*cpow(t_n_a_min, 2) - 8*j_min*cpow(t_s, 2)*t_n_a_min + 8*j_min*cpow(t_n_a_min, 3) + 12*p_0 - 12*p_max - 12*t_s*v_0 - 12*t_n_a_min*v_0)/a_min + (1.0/4.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2)) + (1.0/3.0)*(-1.0/6.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + 2*(((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 2*(-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min)*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), -0.33333333333333331) - 2*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-16*a_0*cpow(t_s, 2) - 12*a_0*t_s*t_n_a_min + 4*a_min*cpow(t_s, 2) + 12*a_min*t_s*t_n_a_min - 12*a_min*cpow(t_n_a_min, 2) - 16*j_min*cpow(t_s, 2)*t_n_a_min + 16*j_min*cpow(t_n_a_min, 3) + 24*p_0 - 24*p_max - 24*t_s*v_0 - 24*t_n_a_min*v_0)/a_min + (1.0/2.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2)) - 1.0/4.0*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min;
   return result;

}

double pos_reduced_jerk_tv0_3(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_n_a_min) {

   double result;
   result = (1.0/12.0)*pow((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2), 2) - (((1.0/16.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*pow(t_s, 2)*pow(t_n_a_min, 2) + a_0*t_s*pow(t_n_a_min, 3) + a_min*pow(t_s, 2)*pow(t_n_a_min, 2) - a_min*t_s*pow(t_n_a_min, 3) - j_min*pow(t_s, 3)*pow(t_n_a_min, 2) + j_min*t_s*pow(t_n_a_min, 4) + 6*p_0*pow(t_s, 2) + 6*p_0*pow(t_n_a_min, 2) - 6*p_max*pow(t_s, 2) - 6*p_max*pow(t_n_a_min, 2) + 2*pow(t_s, 3)*v_0 + 2*pow(t_n_a_min, 3)*v_0)/a_min;
   return result;

}

double pos_reduced_jerk_tv0_4(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_n_a_min) {

   double result;
   result = (1.0/2.0)*sqrt(-2*pow(-1.0/108.0*pow((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*((-((1.0/16.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*pow(t_s, 2)*pow(t_n_a_min, 2) + a_0*t_s*pow(t_n_a_min, 3) + a_min*pow(t_s, 2)*pow(t_n_a_min, 2) - a_min*t_s*pow(t_n_a_min, 3) - j_min*pow(t_s, 3)*pow(t_n_a_min, 2) + j_min*t_s*pow(t_n_a_min, 4) + 6*p_0*pow(t_s, 2) + 6*p_0*pow(t_n_a_min, 2) - 6*p_max*pow(t_s, 2) - 6*p_max*pow(t_n_a_min, 2) + 2*pow(t_s, 3)*v_0 + 2*pow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*pow(((1.0/2.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 0.33333333333333331) - 1.0/3.0*(-8*a_0*pow(t_s, 2) - 6*a_0*t_s*t_n_a_min + 2*a_min*pow(t_s, 2) + 6*a_min*t_s*t_n_a_min - 6*a_min*pow(t_n_a_min, 2) - 8*j_min*pow(t_s, 2)*t_n_a_min + 8*j_min*pow(t_n_a_min, 3) + 12*p_0 - 12*p_max - 12*t_s*v_0 - 12*t_n_a_min*v_0)/a_min + (1.0/4.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2)) + (1.0/2.0)*sqrt((-((4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/4.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min - (4*a_0*pow(t_s, 3) + 4*a_0*pow(t_s, 2)*t_n_a_min - 4*a_min*pow(t_s, 2)*t_n_a_min + 4*a_min*pow(t_n_a_min, 3) + 4*j_min*pow(t_s, 3)*t_n_a_min + 4*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 4*j_min*t_s*pow(t_n_a_min, 3) - 4*j_min*pow(t_n_a_min, 4) - 24*p_0*t_s - 24*p_0*t_n_a_min + 24*p_max*t_s + 24*p_max*t_n_a_min)/a_min)/sqrt(-2*pow(-1.0/108.0*pow((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*((-((1.0/16.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*pow(t_s, 2)*pow(t_n_a_min, 2) + a_0*t_s*pow(t_n_a_min, 3) + a_min*pow(t_s, 2)*pow(t_n_a_min, 2) - a_min*t_s*pow(t_n_a_min, 3) - j_min*pow(t_s, 3)*pow(t_n_a_min, 2) + j_min*t_s*pow(t_n_a_min, 4) + 6*p_0*pow(t_s, 2) + 6*p_0*pow(t_n_a_min, 2) - 6*p_max*pow(t_s, 2) - 6*p_max*pow(t_n_a_min, 2) + 2*pow(t_s, 3)*v_0 + 2*pow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*pow(((1.0/2.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 0.33333333333333331) - 1.0/3.0*(-8*a_0*pow(t_s, 2) - 6*a_0*t_s*t_n_a_min + 2*a_min*pow(t_s, 2) + 6*a_min*t_s*t_n_a_min - 6*a_min*pow(t_n_a_min, 2) - 8*j_min*pow(t_s, 2)*t_n_a_min + 8*j_min*pow(t_n_a_min, 3) + 12*p_0 - 12*p_max - 12*t_s*v_0 - 12*t_n_a_min*v_0)/a_min + (1.0/4.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2)) + 2*pow(-1.0/108.0*pow((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*pow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*pow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*pow(t_n_a_min, 2) - 4*j_min*pow(t_s, 2)*t_n_a_min + 4*j_min*pow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*((-((1.0/16.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*pow(t_s, 2)*pow(t_n_a_min, 2) + a_0*t_s*pow(t_n_a_min, 3) + a_min*pow(t_s, 2)*pow(t_n_a_min, 2) - a_min*t_s*pow(t_n_a_min, 3) - j_min*pow(t_s, 3)*pow(t_n_a_min, 2) + j_min*t_s*pow(t_n_a_min, 4) + 6*p_0*pow(t_s, 2) + 6*p_0*pow(t_n_a_min, 2) - 6*p_max*pow(t_s, 2) - 6*p_max*pow(t_n_a_min, 2) + 2*pow(t_s, 3)*v_0 + 2*pow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*pow(((1.0/2.0)*(4*a_0*pow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*pow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*pow(t_n_a_min, 2) + 4*j_min*pow(t_s, 2)*t_n_a_min - 4*j_min*pow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*pow(t_s, 3) + 2*a_0*pow(t_s, 2)*t_n_a_min - 2*a_min*pow(t_s, 2)*t_n_a_min + 2*a_min*pow(t_n_a_min, 3) + 2*j_min*pow(t_s, 3)*t_n_a_min + 2*j_min*pow(t_s, 2)*pow(t_n_a_min, 2) - 2*j_min*t_s*pow(t_n_a_min, 3) - 2*j_min*pow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 0.33333333333333331) - 1.0/3.0*(-16*a_0*pow(t_s, 2) - 12*a_0*t_s*t_n_a_min + 4*a_min*pow(t_s, 2) + 12*a_min*t_s*t_n_a_min - 12*a_min*pow(t_n_a_min, 2) - 16*j_min*pow(t_s, 2)*t_n_a_min + 16*j_min*pow(t_n_a_min, 3) + 24*p_0 - 24*p_max - 24*t_s*v_0 - 24*t_n_a_min*v_0)/a_min + (1.0/2.0)*pow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0, 2)/pow(a_min, 2)) - 1.0/4.0*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*pow(t_n_a_min, 2) + 4*v_0)/a_min;
   return result;

}

double complex pos_reduced_jerk_tv0_5(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s, double t_n_a_min) {

   double complex result;
   result = (1.0/2.0)*csqrt((1.0/3.0)*((1.0/6.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) - 2*(((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + 2*(-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min)*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), -0.33333333333333331) + 2*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-8*a_0*cpow(t_s, 2) - 6*a_0*t_s*t_n_a_min + 2*a_min*cpow(t_s, 2) + 6*a_min*t_s*t_n_a_min - 6*a_min*cpow(t_n_a_min, 2) - 8*j_min*cpow(t_s, 2)*t_n_a_min + 8*j_min*cpow(t_n_a_min, 3) + 12*p_0 - 12*p_max - 12*t_s*v_0 - 12*t_n_a_min*v_0)/a_min + (1.0/4.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2)) + (1.0/2.0)*csqrt((-((4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/4.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (4*a_0*cpow(t_s, 3) + 4*a_0*cpow(t_s, 2)*t_n_a_min - 4*a_min*cpow(t_s, 2)*t_n_a_min + 4*a_min*cpow(t_n_a_min, 3) + 4*j_min*cpow(t_s, 3)*t_n_a_min + 4*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 4*j_min*t_s*cpow(t_n_a_min, 3) - 4*j_min*cpow(t_n_a_min, 4) - 24*p_0*t_s - 24*p_0*t_n_a_min + 24*p_max*t_s + 24*p_max*t_n_a_min)/a_min)/csqrt((1.0/3.0)*((1.0/6.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) - 2*(((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + 2*(-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min)*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), -0.33333333333333331) + 2*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-8*a_0*cpow(t_s, 2) - 6*a_0*t_s*t_n_a_min + 2*a_min*cpow(t_s, 2) + 6*a_min*t_s*t_n_a_min - 6*a_min*cpow(t_n_a_min, 2) - 8*j_min*cpow(t_s, 2)*t_n_a_min + 8*j_min*cpow(t_n_a_min, 3) + 12*p_0 - 12*p_max - 12*t_s*v_0 - 12*t_n_a_min*v_0)/a_min + (1.0/4.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2)) + (1.0/3.0)*(-1.0/6.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + 2*(((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 2*(-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min)*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), -0.33333333333333331) - 2*cpow((1.0/216.0)*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) - 1.0/6.0*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) + (1.0/16.0)*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2) + csqrt((1.0/27.0)*cpow(-1.0/12.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 2) + (((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (1.0/4.0)*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min, 3) + (1.0/4.0)*cpow(-1.0/108.0*cpow((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2), 3) + (1.0/3.0)*((-4*a_0*cpow(t_s, 2) - 3*a_0*t_s*t_n_a_min + a_min*cpow(t_s, 2) + 3*a_min*t_s*t_n_a_min - 3*a_min*cpow(t_n_a_min, 2) - 4*j_min*cpow(t_s, 2)*t_n_a_min + 4*j_min*cpow(t_n_a_min, 3) + 6*p_0 - 6*p_max - 6*t_s*v_0 - 6*t_n_a_min*v_0)/a_min - 3.0/8.0*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*((-((1.0/16.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (3.0/256.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min - 1.0/4.0*(2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min)*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (-a_0*cpow(t_s, 2)*cpow(t_n_a_min, 2) + a_0*t_s*cpow(t_n_a_min, 3) + a_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - a_min*t_s*cpow(t_n_a_min, 3) - j_min*cpow(t_s, 3)*cpow(t_n_a_min, 2) + j_min*t_s*cpow(t_n_a_min, 4) + 6*p_0*cpow(t_s, 2) + 6*p_0*cpow(t_n_a_min, 2) - 6*p_max*cpow(t_s, 2) - 6*p_max*cpow(t_n_a_min, 2) + 2*cpow(t_s, 3)*v_0 + 2*cpow(t_n_a_min, 3)*v_0)/a_min) - 1.0/8.0*cpow(((1.0/2.0)*(4*a_0*cpow(t_s, 2) + 3*a_0*t_s*t_n_a_min - a_min*cpow(t_s, 2) - 3*a_min*t_s*t_n_a_min + 3*a_min*cpow(t_n_a_min, 2) + 4*j_min*cpow(t_s, 2)*t_n_a_min - 4*j_min*cpow(t_n_a_min, 3) - 6*p_0 + 6*p_max + 6*t_s*v_0 + 6*t_n_a_min*v_0)/a_min + (1.0/8.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2))*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min + (2*a_0*cpow(t_s, 3) + 2*a_0*cpow(t_s, 2)*t_n_a_min - 2*a_min*cpow(t_s, 2)*t_n_a_min + 2*a_min*cpow(t_n_a_min, 3) + 2*j_min*cpow(t_s, 3)*t_n_a_min + 2*j_min*cpow(t_s, 2)*cpow(t_n_a_min, 2) - 2*j_min*t_s*cpow(t_n_a_min, 3) - 2*j_min*cpow(t_n_a_min, 4) - 12*p_0*t_s - 12*p_0*t_n_a_min + 12*p_max*t_s + 12*p_max*t_n_a_min)/a_min, 2), 2)), 0.33333333333333331) - 1.0/3.0*(-16*a_0*cpow(t_s, 2) - 12*a_0*t_s*t_n_a_min + 4*a_min*cpow(t_s, 2) + 12*a_min*t_s*t_n_a_min - 12*a_min*cpow(t_n_a_min, 2) - 16*j_min*cpow(t_s, 2)*t_n_a_min + 16*j_min*cpow(t_n_a_min, 3) + 24*p_0 - 24*p_max - 24*t_s*v_0 - 24*t_n_a_min*v_0)/a_min + (1.0/2.0)*cpow(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0, 2)/cpow(a_min, 2)) - 1.0/4.0*(2*a_0*t_s - 2*a_min*t_s + 2*j_min*t_s*t_n_a_min - 2*j_min*cpow(t_n_a_min, 2) + 4*v_0)/a_min;
   return result;

}

double pos_upper_bound_a1_max_0(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) + (1.0/12.0)*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2);
   return result;

}

double pos_upper_bound_a1_max_1(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = (2.0/3.0)*a_min + (1.0/2.0)*j_min*t_s + (1.0/2.0)*sqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*pow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)) + (1.0/2.0)*sqrt((8.0/3.0)*a_0*j_min*t_s - 8.0/3.0*pow(a_min, 2) - 16.0/3.0*a_min*j_min*t_s - 4.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (16.0/3.0)*j_min*v_0 + (1.0/2.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) + 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331) - (8*a_0*a_min*j_min*t_s + 4*a_0*pow(j_min, 2)*pow(t_s, 2) - 4*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 16*a_min*j_min*v_0 + 8*pow(j_min, 2)*t_s*v_0 + (-16.0/3.0*a_min - 4*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))/sqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*pow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)));
   return result;

}

double complex pos_upper_bound_a1_max_2(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double complex result;
   result = (2.0/3.0)*a_min + (1.0/2.0)*j_min*t_s + (1.0/2.0)*csqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*cpow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 1.0/3.0*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) + 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)) + (1.0/2.0)*csqrt((8.0/3.0)*a_0*j_min*t_s - 8.0/3.0*cpow(a_min, 2) - 16.0/3.0*a_min*j_min*t_s - 4.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (16.0/3.0)*j_min*v_0 + (1.0/2.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) + (1.0/3.0)*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) - 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331) - (8*a_0*a_min*j_min*t_s + 4*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 4*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 16*a_min*j_min*v_0 + 8*cpow(j_min, 2)*t_s*v_0 + (-16.0/3.0*a_min - 4*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))/csqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*cpow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 1.0/3.0*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) + 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)));
   return result;

}

double pos_upper_bound_a1_max_3(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) + (1.0/12.0)*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2);
   return result;

}

double pos_upper_bound_a1_max_4(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = (2.0/3.0)*a_min + (1.0/2.0)*j_min*t_s - 1.0/2.0*sqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*pow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)) + (1.0/2.0)*sqrt((8.0/3.0)*a_0*j_min*t_s - 8.0/3.0*pow(a_min, 2) - 16.0/3.0*a_min*j_min*t_s - 4.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (16.0/3.0)*j_min*v_0 + (1.0/2.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) + 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331) + (8*a_0*a_min*j_min*t_s + 4*a_0*pow(j_min, 2)*pow(t_s, 2) - 4*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 16*a_min*j_min*v_0 + 8*pow(j_min, 2)*t_s*v_0 + (-16.0/3.0*a_min - 4*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))/sqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*pow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)));
   return result;

}

double complex pos_upper_bound_a1_max_5(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double complex result;
   result = (2.0/3.0)*a_min + (1.0/2.0)*j_min*t_s - 1.0/2.0*csqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*cpow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 1.0/3.0*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) + 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)) + (1.0/2.0)*csqrt((8.0/3.0)*a_0*j_min*t_s - 8.0/3.0*cpow(a_min, 2) - 16.0/3.0*a_min*j_min*t_s - 4.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (16.0/3.0)*j_min*v_0 + (1.0/2.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) + (1.0/3.0)*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) - 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331) + (8*a_0*a_min*j_min*t_s + 4*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 4*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 16*a_min*j_min*v_0 + 8*cpow(j_min, 2)*t_s*v_0 + (-16.0/3.0*a_min - 4*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))/csqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*cpow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 1.0/3.0*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) + 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)));
   return result;

}

double pos_upper_bound_a1_min_0(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) + (1.0/12.0)*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2);
   return result;

}

double pos_upper_bound_a1_min_1(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = (2.0/3.0)*a_min + (1.0/2.0)*j_min*t_s - 1.0/2.0*sqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*pow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)) - 1.0/2.0*sqrt((8.0/3.0)*a_0*j_min*t_s - 8.0/3.0*pow(a_min, 2) - 16.0/3.0*a_min*j_min*t_s - 4.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (16.0/3.0)*j_min*v_0 + (1.0/2.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) + 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331) + (8*a_0*a_min*j_min*t_s + 4*a_0*pow(j_min, 2)*pow(t_s, 2) - 4*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 16*a_min*j_min*v_0 + 8*pow(j_min, 2)*t_s*v_0 + (-16.0/3.0*a_min - 4*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))/sqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*pow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)));
   return result;

}

double complex pos_upper_bound_a1_min_2(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double complex result;
   result = (2.0/3.0)*a_min + (1.0/2.0)*j_min*t_s - 1.0/2.0*csqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*cpow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 1.0/3.0*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) + 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)) - 1.0/2.0*csqrt((8.0/3.0)*a_0*j_min*t_s - 8.0/3.0*cpow(a_min, 2) - 16.0/3.0*a_min*j_min*t_s - 4.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (16.0/3.0)*j_min*v_0 + (1.0/2.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) + (1.0/3.0)*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) - 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331) + (8*a_0*a_min*j_min*t_s + 4*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 4*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 16*a_min*j_min*v_0 + 8*cpow(j_min, 2)*t_s*v_0 + (-16.0/3.0*a_min - 4*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))/csqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*cpow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 1.0/3.0*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) + 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)));
   return result;

}

double pos_upper_bound_a1_min_3(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) + (1.0/12.0)*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2);
   return result;

}

double pos_upper_bound_a1_min_4(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double result;
   result = (2.0/3.0)*a_min + (1.0/2.0)*j_min*t_s + (1.0/2.0)*sqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*pow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)) - 1.0/2.0*sqrt((8.0/3.0)*a_0*j_min*t_s - 8.0/3.0*pow(a_min, 2) - 16.0/3.0*a_min*j_min*t_s - 4.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (16.0/3.0)*j_min*v_0 + (1.0/2.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) + 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331) - (8*a_0*a_min*j_min*t_s + 4*a_0*pow(j_min, 2)*pow(t_s, 2) - 4*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 16*a_min*j_min*v_0 + 8*pow(j_min, 2)*t_s*v_0 + (-16.0/3.0*a_min - 4*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))/sqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*pow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*pow(j_min, 2)*pow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 2*pow(-1.0/108.0*pow(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*pow(a_min, 2) + 4*a_min*j_min*t_s + pow(j_min, 2)*pow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(pow(a_0, 2)*pow(j_min, 2)*pow(t_s, 2) - 2*a_0*pow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*pow(j_min, 2)*pow(t_s, 2) + 4*a_0*pow(j_min, 2)*t_s*v_0 - 1.0/3.0*pow(a_min, 4) - 4*pow(a_min, 2)*j_min*v_0 - 8*a_min*pow(j_min, 2)*p_0 + 8*a_min*pow(j_min, 2)*p_max - 8*a_min*pow(j_min, 2)*t_s*v_0 + 4*pow(j_min, 2)*pow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*pow(j_min, 2)*pow(t_s, 2) - 1.0/2.0*pow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 2*a_min*j_min*v_0 + pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*pow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*pow(j_min, 2)*pow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*pow(4*a_0*a_min*j_min*t_s + 2*a_0*pow(j_min, 2)*pow(t_s, 2) - 2*pow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*pow(j_min, 2)*pow(t_s, 2) + 8*a_min*j_min*v_0 + 4*pow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - pow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*pow(j_min, 2)*pow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*pow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)));
   return result;

}

double complex pos_upper_bound_a1_min_5(double j_min, double a_0, double a_min, double v_0, double p_0, double p_max, double t_s) {

   double complex result;
   result = (2.0/3.0)*a_min + (1.0/2.0)*j_min*t_s + (1.0/2.0)*csqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*cpow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 1.0/3.0*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) + 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)) - 1.0/2.0*csqrt((8.0/3.0)*a_0*j_min*t_s - 8.0/3.0*cpow(a_min, 2) - 16.0/3.0*a_min*j_min*t_s - 4.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (16.0/3.0)*j_min*v_0 + (1.0/2.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) + (1.0/3.0)*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) - 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331) - (8*a_0*a_min*j_min*t_s + 4*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 4*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 16*a_min*j_min*v_0 + 8*cpow(j_min, 2)*t_s*v_0 + (-16.0/3.0*a_min - 4*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))/csqrt((4.0/3.0)*a_0*j_min*t_s - 4.0/3.0*cpow(a_min, 2) - 8.0/3.0*a_min*j_min*t_s - 2.0/3.0*cpow(j_min, 2)*cpow(t_s, 2) + (8.0/3.0)*j_min*v_0 + (1.0/4.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2) - 1.0/3.0*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), -0.33333333333333331)*(-2*cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(a_min, 2)*j_min*t_s + (16.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 8*a_0*cpow(j_min, 2)*t_s*v_0 + (2.0/3.0)*cpow(a_min, 4) + 8*cpow(a_min, 2)*j_min*v_0 + 16*a_min*cpow(j_min, 2)*p_0 - 16*a_min*cpow(j_min, 2)*p_max + 16*a_min*cpow(j_min, 2)*t_s*v_0 - 8*cpow(j_min, 2)*cpow(v_0, 2) + 2*(-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/6.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2)) + 2*cpow(csqrt((1.0/4.0)*cpow(-1.0/108.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) + (1.0/3.0)*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) - 1.0/8.0*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 2) + (1.0/27.0)*cpow(-cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_0*cpow(a_min, 2)*j_min*t_s + (8.0/3.0)*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) - 4*a_0*cpow(j_min, 2)*t_s*v_0 + (1.0/3.0)*cpow(a_min, 4) + 4*cpow(a_min, 2)*j_min*v_0 + 8*a_min*cpow(j_min, 2)*p_0 - 8*a_min*cpow(j_min, 2)*p_max + 8*a_min*cpow(j_min, 2)*t_s*v_0 - 4*cpow(j_min, 2)*cpow(v_0, 2) + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))) - 1.0/12.0*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 2), 3)) + (1.0/216.0)*cpow(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2), 3) - 1.0/6.0*(-2*a_0*j_min*t_s + 2*cpow(a_min, 2) + 4*a_min*j_min*t_s + cpow(j_min, 2)*cpow(t_s, 2) - 4*j_min*v_0 - 3.0/8.0*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2))*(cpow(a_0, 2)*cpow(j_min, 2)*cpow(t_s, 2) - 2*a_0*cpow(a_min, 2)*j_min*t_s - 8.0/3.0*a_0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 4*a_0*cpow(j_min, 2)*t_s*v_0 - 1.0/3.0*cpow(a_min, 4) - 4*cpow(a_min, 2)*j_min*v_0 - 8*a_min*cpow(j_min, 2)*p_0 + 8*a_min*cpow(j_min, 2)*p_max - 8*a_min*cpow(j_min, 2)*t_s*v_0 + 4*cpow(j_min, 2)*cpow(v_0, 2) - (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*a_min*j_min*t_s + (1.0/2.0)*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 1.0/2.0*cpow(a_min, 2)*j_min*t_s - 1.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 2*a_min*j_min*v_0 + cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*((1.0/8.0)*a_0*j_min*t_s - 1.0/8.0*cpow(a_min, 2) - 1.0/4.0*a_min*j_min*t_s - 1.0/16.0*cpow(j_min, 2)*cpow(t_s, 2) + (1.0/4.0)*j_min*v_0 + (3.0/256.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)))) + (1.0/16.0)*cpow(4*a_0*a_min*j_min*t_s + 2*a_0*cpow(j_min, 2)*cpow(t_s, 2) - 2*cpow(a_min, 2)*j_min*t_s - 4.0/3.0*a_min*cpow(j_min, 2)*cpow(t_s, 2) + 8*a_min*j_min*v_0 + 4*cpow(j_min, 2)*t_s*v_0 + (-8.0/3.0*a_min - 2*j_min*t_s)*(a_0*j_min*t_s - cpow(a_min, 2) - 2*a_min*j_min*t_s - 1.0/2.0*cpow(j_min, 2)*cpow(t_s, 2) + 2*j_min*v_0 + (1.0/8.0)*cpow(-8.0/3.0*a_min - 2*j_min*t_s, 2)), 2), 0.33333333333333331)));
   return result;

}

double pos_upper_bound_tv0(double j_min, double a_0, double a_1, double a_min, double v_0, double t_s) {

   double result;
   result = (1.0/2.0)*(-2*a_0*t_s + 2*a_min*(t_s - (a_1 - a_min)/j_min) + j_min*pow(t_s, 2) - j_min*pow(t_s - (a_1 - a_min)/j_min, 2) + t_s*(a_0 - a_1) + 2*t_s*(a_1 - j_min*t_s) - 2*v_0 - (2*a_1 - 2*j_min*t_s)*(t_s - (a_1 - a_min)/j_min))/a_min;
   return result;

}

double vel_reduced_a1_max(double j_min, double a_0, double a_n_plus_1_star, double v_0, double v_max, double t_s, double t_n) {

   double result;
   result = (1.0/4.0)*(-a_0*t_s - a_n_plus_1_star*t_s + 2*a_n_plus_1_star*t_n + 3*j_min*t_s*t_n - 3*j_min*pow(t_n, 2) - 2*v_0 + 2*v_max + sqrt(pow(a_0, 2)*pow(t_s, 2) + 2*a_0*a_n_plus_1_star*pow(t_s, 2) + 4*a_0*a_n_plus_1_star*t_s*t_n + 2*a_0*j_min*pow(t_s, 2)*t_n - 2*a_0*j_min*t_s*pow(t_n, 2) + 4*a_0*t_s*v_0 - 4*a_0*t_s*v_max + pow(a_n_plus_1_star, 2)*pow(t_s, 2) - 4*pow(a_n_plus_1_star, 2)*t_s*t_n + 4*pow(a_n_plus_1_star, 2)*pow(t_n, 2) + 2*a_n_plus_1_star*j_min*pow(t_s, 2)*t_n + 2*a_n_plus_1_star*j_min*t_s*pow(t_n, 2) - 4*a_n_plus_1_star*j_min*pow(t_n, 3) + 4*a_n_plus_1_star*t_s*v_0 - 4*a_n_plus_1_star*t_s*v_max + 8*a_n_plus_1_star*t_n*v_0 - 8*a_n_plus_1_star*t_n*v_max + pow(j_min, 2)*pow(t_s, 2)*pow(t_n, 2) - 2*pow(j_min, 2)*t_s*pow(t_n, 3) + pow(j_min, 2)*pow(t_n, 4) + 4*j_min*t_s*t_n*v_0 - 4*j_min*t_s*t_n*v_max - 4*j_min*pow(t_n, 2)*v_0 + 4*j_min*pow(t_n, 2)*v_max + 4*pow(v_0, 2) - 8*v_0*v_max + 4*pow(v_max, 2)))/t_n;
   return result;

}

double vel_reduced_a1_min(double j_min, double a_0, double a_n_plus_1_star, double v_0, double v_max, double t_s, double t_n) {

   double result;
   result = (1.0/4.0)*(-a_0*t_s - a_n_plus_1_star*t_s + 2*a_n_plus_1_star*t_n + 3*j_min*t_s*t_n - 3*j_min*pow(t_n, 2) - 2*v_0 + 2*v_max - sqrt(pow(a_0, 2)*pow(t_s, 2) + 2*a_0*a_n_plus_1_star*pow(t_s, 2) + 4*a_0*a_n_plus_1_star*t_s*t_n + 2*a_0*j_min*pow(t_s, 2)*t_n - 2*a_0*j_min*t_s*pow(t_n, 2) + 4*a_0*t_s*v_0 - 4*a_0*t_s*v_max + pow(a_n_plus_1_star, 2)*pow(t_s, 2) - 4*pow(a_n_plus_1_star, 2)*t_s*t_n + 4*pow(a_n_plus_1_star, 2)*pow(t_n, 2) + 2*a_n_plus_1_star*j_min*pow(t_s, 2)*t_n + 2*a_n_plus_1_star*j_min*t_s*pow(t_n, 2) - 4*a_n_plus_1_star*j_min*pow(t_n, 3) + 4*a_n_plus_1_star*t_s*v_0 - 4*a_n_plus_1_star*t_s*v_max + 8*a_n_plus_1_star*t_n*v_0 - 8*a_n_plus_1_star*t_n*v_max + pow(j_min, 2)*pow(t_s, 2)*pow(t_n, 2) - 2*pow(j_min, 2)*t_s*pow(t_n, 3) + pow(j_min, 2)*pow(t_n, 4) + 4*j_min*t_s*t_n*v_0 - 4*j_min*t_s*t_n*v_max - 4*j_min*pow(t_n, 2)*v_0 + 4*j_min*pow(t_n, 2)*v_max + 4*pow(v_0, 2) - 8*v_0*v_max + 4*pow(v_max, 2)))/t_n;
   return result;

}